# -*- coding: utf-8 -*-
#(c) Julia SchÃ¶nhart
#(c) Daniela Zierler

import gtk
import pygtk
import pango
import random
import copy
from sugar.graphics import style

from exercise import Exercise
from functions import *

class ExAddSub(Exercise):
    def __init__(self, dis, (sett, errors)):
        self._display = dis
        self._errors = errors
        self._sett = sett
#        {'topic'    : 'exaddsub',
#         'title'    : 'Template: +- in a column',
#         'descript' : 'TODO',
#         'icon'     : None, # for quick reference of the exercise
#         'calclines': 4,    # no. of lines for calc to be input.
#         'MAX'      : 10,   # maximum of calcs generated.
#         'MIN'      : 10,   # minimum of calcs generated UNUSED
#         'length'   :  3,   # maximal number of digits of summands
                             # FIXXXME _max_length = 7
#         'args'     :  2,   # FIXED due to constraints in
#                            # _generate_calcs and format
#         'carry'    : False,# the calculation might involve carries
#         'ops'      : ["+", "-"],#["+", "-"] are the only options
#         'shuffle'  : True,
#         'cut-max'  : True  # cut set of all calcs down to MAX
#        }
        self._calcs = self._generate_calcs()

    def _generate_calcs(self):
        _sett = self._sett
        _ops = self._create_ops(_sett) #with length _sett['MAX']
        _calcs = []
        for _c in range(_sett['MAX']):
            _arg1 = []
            for _i in range(0,_sett['length']):      
                _d = random.randint(0,9)
                _arg1.append(_d)
            #TODO remove leading 0s
            #print('in _generate_calcs: _arg1=', _arg1)
            if _ops[_c] == "+":
                if _sett['carry']:
                    _arg2 = self._add_carry(_sett)
                else:
                    _arg2 = self._add_no_carry(_sett, _arg1)
                _res = ints2int(_arg1) + ints2int(_arg2)
            else: # "-"
                if _sett['carry']:
                    _arg1, _arg2 = self._sub_carry(_sett, _arg1)
                else:
                    _arg2 = self._sub_no_carry(_sett, _arg1)
                _res = ints2int(_arg1) - ints2int(_arg2)
            #TODO remove leading 0s
            _calc = [[str(x) for x in _arg1], 
                     _ops[_c], 
                     [str(x) for x in _arg2], 
                     '=', 
                     int2strs(_res)]
            _calcs.append(flatten(_calc))
        return _calcs
    
    def _add_no_carry(self, _sett, _arg1):
        """create arg2 such that addition with arg1
        does NOT create a carry"""
        _arg2 = []
        for _a1 in _arg1:
            _arg2.append(random.randint(0, 9 - _a1))
        return _arg2
    #_arg1 = [9,5,1]
    #print("_add_no_carry(_sett, _arg1)=", _add_no_carry(_sett, _arg1))
    def _add_carry(self, _sett):
        """create an arbitrary arg2 for addition"""
        _arg2 = []
        for _a1 in range(_sett['length']):
            _arg2.append(random.randint(0, 9))
        return _arg2
    
    def _sub_no_carry(self, _sett, _arg1):
        """create arg2 such that subtraction from arg1
        does NOT create a carry"""
        _arg2 = []
        for _a1 in _arg1:
            _arg2.append(random.randint(0, _a1))
        return _arg2
    #_arg1 = [9,5,0]
    #print("_sub_no_carry(_sett, _arg1)=", _sub_no_carry(_sett, _arg1))
    def _sub_carry(self, _sett, _arg1):
        """create an arbitrary arg2, compare with arg1
        and take larger number"""
        _arg2 = []
        for _a1 in range(_sett['length']):
            _arg2.append(random.randint(0, 9))
        if ints2int(_arg1) < ints2int(_arg2):
            _save = copy.deepcopy(_arg1)
            _arg1 = copy.deepcopy(_arg2)
            _arg2 = copy.deepcopy(_save)
        return (_arg1, _arg2)
    #_arg1 = [9,5,0]
    #print("_sub_carry(_sett, _arg1)=", _sub_carry(_sett, _arg1))
    #_arg1 = [1,1,1]
    #print("_sub_carry(_sett, _arg1)=", _sub_carry(_sett, _arg1))
    
    def _create_ops(self, _sett):
        _ops = []
        if ('+' in _sett['ops']) and ('-' in _sett['ops']):
            _adds = _sett['MAX'] / 2
            _subs = _sett['MAX'] - _adds
            for _i in range(_adds):
                 _ops.append("+")
            for _i in range(_subs):
                 _ops.append("-")
        elif '+' in _sett['ops']:
            for _i in range(_sett['MAX']):
                 _ops.append("+")
        elif '-' in _sett['ops']:
            for _i in range(_sett['MAX']):
                 _ops.append("-")
        else:
            print("ERROR exercises.exaddsub._create_ops: \
                   _sett['ops'] must not be empty; RECOVERED")
            for _i in range(_sett['MAX']):
                 _ops.append("+")
        if _sett['shuffle']:
            random.shuffle(_ops)
        return _ops

    def format(self, calc):
        """format the calc for display, prepare overlays for input"""
        _ccs = collect_digits(calc)
        #print('in Display.format_addsub_simp: _ccs=',_ccs )
        _l0 = self._init_lines(_ccs)
        _ip = self._calc_lines(_ccs)
        return (_l0, _ip)

    def _init_lines(self,calc):
        """from ([['6','5'],'+',['4','3'],'=',['1','0','8']])
        make [[' ',' ',' ',' ',' ','6','5',' ',' ',' ',' ',' '],
              [' ',' ',' ',' ','+','4','3',' ',' ',' ',' ',' '],
              [' ',' ',' ',' ','-','-','-',' ',' ',' ',' ',' '],
              [' ',' ',' ',' ','-','-','-',' ',' ',' ',' ',' ']]
        """
        #print('#####exaddsub._init_lines: calc=', calc)
        _width = 14      #FIXXXME: _width = 14 is Display.width, 
        _blanksright = 4 #FIXXXME: _blanksright depends on _width when centering
        _line1 = make_chars(' ', _width - len(calc[0]) - \
                                _blanksright) + \
            calc[0] + \
            make_chars(' ', _blanksright)
        _line2 = make_chars(' ', _width - len(calc[2]) - \
                                _blanksright-1)+[calc[1]]+\
            calc[2] + \
            make_chars(' ', _blanksright)
        _line3 = make_chars(' ', _width - max_len(calc) - \
                                _blanksright) + \
            make_chars('---', max_len(calc)) + \
            make_chars(' ', _blanksright)
        _line4 = make_chars(' ', _width - len(calc[4]) - \
                                _blanksright) +\
            make_chars('_', len(calc[4])) + \
            make_chars(' ', _blanksright)
        return [_line1, _line2, _line3, _line4]

    def _calc_lines(self, calc):
        """from ([['6','5'],'+',['4','3'],'=',['1','0','8']])
        make [(3,6,'8','65+43=___','65+43=__8',
               [' ',' ',' ',' ','-','-','8',' ',' ',' ',' ',' ']),
              (3,5,'0','65+43=__8','65+43=_08',
               [' ',' ',' ',' ','-','0','8',' ',' ',' ',' ',' ']),
              (3,4,'1','65+43=_08','65+43=108',
               [' ',' ',' ',' ','1','0','8',' ',' ',' ',' ',' '])]
        TODO _width = 14 is Display.width, 
        TODO _blanksright depends on _width when centering
        """
        _blanksright = 4
        _width = 14
        _lines = []
        _sum = calc[4]
        _lensum = len(_sum)
        _protoc = flatten(calc[0:-1]) + make_chars('_', len(_sum))
        for i in range (len(_sum)):
            _input = _sum.pop()
            _protoc2 = copy.deepcopy(_protoc)
            _protoc2[len(_protoc)-i-1] = _input
            _line = (3, 10 - i -1, _input, 
                     strs2str(flatten(_protoc)), strs2str(flatten(_protoc2)),
                     make_chars(' ', _width - _lensum - _blanksright) + 
                     _protoc2[-_lensum:]  + 
                     make_chars(' ', _blanksright))
            _lines.append(_line)
            _protoc = copy.deepcopy(_protoc2)
        _lines.reverse()
        return _lines

    def make_blanks(self,num_blanks):
        _c = [' ']
        for i in range(1,num_blanks+1):
            _c.append(' ')
        return _c

    def make_underline(self,num_underline):
        _c = []
        for i in range(1,num_underline+1):
            _c.append('_')
        return _c

    ### buttons ################################################

    def define_buttons(self):

        # Buttons V top 
        self.arrow_butts = []
        for i in range(7):
            self.toggle = gtk.ToggleButton("V")
            self.toggle_label = self.toggle.get_child()
            self.toggle.modify_font(pango.FontDescription("sans 12"))
            self.toggle.connect("toggled", self.toggle_arrow_callback, i)
            self._display.settings_table.attach(self.toggle, 1+i, 2+i, 3, 4 )
            self.toggle.show()
            self.arrow_butts.append(self.toggle)

        # Buttons < right
        self.dice_butts = []
        for i in range(3):
            self.toggle = gtk.ToggleButton("<")
            self.toggle_label = self.toggle.get_child()
            self.toggle.modify_font(pango.FontDescription("sans 12"))
            self.toggle.connect("toggled", self.toggle_dice_callback, i)
            self._display.settings_table.attach(self.toggle, 8, 9, 4+i, 5+i)
            self.toggle.show()
            self.dice_butts.append(self.toggle)
        self.numbers = []
        for i in range(4):
            self.label = gtk.Label(str(i+1))
            self.label.modify_font(pango.FontDescription("sans 12"))
            self._display.settings_table.attach(self.label, 4+i, 5+i, 4, 5)
            self.label.show()
            self.numbers.append(self.label)
        self.numbers = []
        for i in range(4):
            self.label = gtk.Label(str(8-i))
            self.label.modify_font(pango.FontDescription("sans 12"))
            self._display.settings_table.attach(self.label, 4+i, 5+i, 6, 7)
            self.label.show()
            self.numbers.append(self.label)
        self.numbers = []
        for i in range(4):
            self.label = gtk.Label('-------')
            self.label.modify_font(pango.FontDescription("sans 12"))
            self._display.settings_table.attach(self.label, 4+i, 5+i, 7, 8)
            self.label.show()
            self.numbers.append(self.label)
        self.numbers = []
        for i in range(4):
            self.label = gtk.Label('9')
            self.label.modify_font(pango.FontDescription("sans 12"))
            self._display.settings_table.attach(self.label, 4+i, 5+i, 8, 9)
            self.label.show()
            self.numbers.append(self.label)

        # carry Button
        self.toggle_carry = gtk.ToggleButton('--10-->')
        self.toggle_label = self.toggle_carry.get_child()
        self.toggle_label.modify_font(pango.\
                                 FontDescription("sans %d" % style.zoom(12)))
        self.toggle_carry.connect("toggled", self.toggle_carry_callback)
        self._display.settings_table.attach(self.toggle_carry, 1, 4, 9, 10)
        self.toggle_carry.show()

        # + Button
        self.toggle_plus = gtk.ToggleButton("+")
        self.toggle_label = self.toggle_plus.get_child()
        self.toggle_label.modify_font(pango.\
                                 FontDescription("sans %d" % style.zoom(12)))
        self.toggle_plus.connect("toggled", self.toggle_plus_callback)
        self._display.settings_table.attach(self.toggle_plus, 3, 4, 6, 7)
        self.toggle_plus.show()

        # - Button
        self.toggle_minus = gtk.ToggleButton("-")
        self.toggle_label = self.toggle_minus.get_child()
        self.toggle_label.modify_font(pango.
                                 FontDescription("sans %d" % style.zoom(12)))
        self.toggle_minus.connect("toggled", self.toggle_minus_callback)
        self._display.settings_table.attach(self.toggle_minus, 2, 3, 6, 7)
        self.toggle_minus.show()

    def set_buttons(self, sett):
        #print("#####exaddsub.set_buttons, sett=", sett)
        _max_length = 7 #FIXXXME ExAddSub._max_length !
        for i in range(_max_length):
            if  i < _max_length - self._sett['length']:
                self.arrow_butts[i].set_active(False)
            else:
                self.arrow_butts[i].set_active(True)
            
        for i in range(2):
            self.dice_butts[i].set_active(False)
            #TODO for higher columns

        if ('+' in sett['ops']):
            self.toggle_plus.set_active(True)
        else:
            self.toggle_plus.set_active(False)

        if ('-' in sett['ops']):
            self.toggle_minus.set_active(True)
        else:
            self.toggle_minus.set_active(False)


    #**** callbacks ***********************************************

    def toggle_arrow_callback(self, widget, clickno):
        _max_length = 7 #FIXXXME class variable of ExAddSub
        if widget.get_active(): #gtk made just active
            if(_max_length - clickno > self._sett['length']):
                #print('exmult.set_len1_callback, le-cl > fact1')
                self._sett['length'] = _max_length - clickno
            elif(_max_length - clickno < 2):
                #print('exmult.set_len1_callback, le-cl < 2')
                pass # not less then "1" button
        else: #gtk made just inactive (before was active)
            #print('exmult.set_len1_callback,.get_active()=False')
            if(_max_length - clickno == self._sett['length']):
                #print('exmult.set_len1_callback, le-cl == fact1')
                if(_max_length - clickno < 2):
                    #print('exmult.set_len1_callback, le-cl < 2')
                    widget.set_active(True)
                else:
                    #print('exmult.set_len1_callback, le-cl >= 2')
                    self._sett['length'] = _max_length - clickno-1
            else:
                #print('exmult.set_len1_callback, le-cl != fact1')
                widget.set_active(True)
        self.set_buttons(self._sett)
#        #print("###toggle_arrow_callback :self._sett=",self._sett)

    def toggle_dice_callback(self, widget, i):
        self.dice_butts[i].set_active(False)
        #TODO for higher columns


    # callbacks updating the settings
    def toggle_carry_callback(self, widget):
        if widget.get_active(): #was active before clicking
            self._sett['carry'] = True
        else: #was inactive before clicking
            self._sett['carry'] = False

    def toggle_plus_callback(self, widget):
        #print('exaddsub.toggle_plus_callback, ops=',
        #      self._sett['ops'])
        if widget.get_active():
            if('+' in self._sett['ops']):
                pass
            else:
                ins_ord(self._sett['ops'], '+')
        else:
            if(len(self._sett['ops']) > 1):
                self._sett['ops'].remove('+')
            else:
                pass
        self.set_buttons(self._sett)
#        if widget.get_active():

    def toggle_minus_callback(self, widget):
        #print('exaddsub.toggle_minus_callback, ops=',
        #      self._sett['ops'])
        if widget.get_active():
            if('-' in self._sett['ops']):
                pass
            else:
                ins_ord(self._sett['ops'], '-')
        else:
            if(len(self._sett['ops']) > 1):
                self._sett['ops'].remove('-')
            else:
                pass
        self.set_buttons(self._sett)
#        if widget.get_active():

    ##### end of public methods #################################
    def _alladd(self, min_pos, max_pos, max_calcs):
        """generate all calcs for +"""
        _adds = []
        _a = 9
        _b = 1
        _num_rand = 0
        
        for i in range(min_pos, max_pos+1):
            _num_rand =  _num_rand+_a*_b
            _b = 10*_b
            
        for i in range (0,max_calcs+1):
            _first_number = random.randint(0, _num_rand)
            _second_number = random.randint(0, _num_rand)
            _ergebnis = _first_number + _second_number
            _c = [to_str_99(_first_number),'+',to_str_99(_second_number),'=', 
                  to_str_99(_ergebnis)]
            _c = flatten(_c)
            _c = strip(_c, '#')
            _adds.append(_c)
          
        #print("in exaddsub._alladd adds= ", _adds)
        return _adds

    def _allsub(self, min_pos,max_pos,max_calcs):
        """generate all calcs for -"""
        _subs = []
        _a = 9
        _b = 1
        _num_rand = 0
        
        for i in range(min_pos, max_pos+1):
            _num_rand =  _num_rand+_a*_b
            _b = 10*_b
        for i in range (0,max_calcs+1):
            _fist_number = random.randint(0, _num_rand)
            _second_number = random.randint(0, _num_rand)
            if _second_number > _fist_number :
                _save = _fist_number
                _fist_number = _second_number
                _second_number = _save
            _ergebnis = _first_number - _second_number
            _c = [to_str_99(_first_number), '-', to_str_99(_second_number), '=', to_str_99(_ergebnis)]
            _c = flatten(_c)
            _c = strip(_c, '#')
            _subs.append(_c)
        return _subs
