# -*- coding: utf-8 -*-
#(c) Christian Hain 2009

import gtk
import pygtk
import pango
import random
import copy
from sugar.graphics import style

from exercise import Exercise
from functions import *

class ExMult(Exercise):
    def __init__(self, dis, (sett, errors)):
        self._dis = dis
        self._errors = errors
        self._sett = sett
#        {'topic'  : 'exmult',
#         'title' : 'Template: * with large numbers',
#         'descript': 'TODO',
#         'icon' : None,     # for quick reference of the exercise      
#         'calclines': 4,    # no. of lines for calc to be input.
#         'MAX'    : 10,     # maximum of calcs generated.
#         'MIN'    : 10,     # minimum of calcs generated UNUSED
#         'fact1'  :  3,     # number of digits of left factor
#         'fact2'  :  1,     # FIXED due to constraints in
#                            # _generate_calcs and format

#         'cut-max': True    # cut set of all calcs down to MAX
#        }
        self._calcs = self._generate_calcs()
                
    def _generate_calcs(self):
        fact1 = self._sett['fact1']
        amount_of_calcs = self._sett['MAX']
        _calcs = []
        for _a in range(amount_of_calcs):
            _fac1 = []
            for _f1 in range(0,fact1):      
                _d = random.randint(0,9)
                _fac1.append(_d)
            #_fac1 = [7,6,5,4,3] #never test with random numbers
            #_fac2 = 2           #never test with random numbers
            _fac2 = random.randint(1,9) #(0,9) incompatible with format!!!
            _res = []
            _carry = 0
            _fac1.reverse() #multiplication starts from last element
            for _d in _fac1:     
                _prod = _d * _fac2
                _prod =  _prod + _carry
                _carry, _r = divmod(_prod, 10)
                _res.append(_r)
            if _carry > 0:
                _res.append(_carry)
            _fac1.reverse()
            _fac1 = [str(x) for x in _fac1]
            _res.reverse()
            _res = [str(x) for x in _res]
            _calc = flatten([_fac1, '*', str(_fac2), '=', _res])
            _calcs.append(_calc)
        #print('Ex._generate_calcs: _calcs=',_calcs)
        return _calcs

    def _init_lines(self, _ccs, _width, _bright):
        """format the calc for display as is befor input starts
        from [['3','2'],'*',['4'],'=',['1','2','8']]
        make ([[' ',' ',' ',' ',' ',' ','3','2',' ','*',' ','4',' ',' '],
               [' ',' ',' ',' ',' ','-','-','-','-','-','-','-',' ',' '],
               [' ',' ',' ',' ',' ','1','1','8',' ',' ',' ',' ',' ',' ']],
              [TDOD])
        """
        _line1 = make_chars(' ',_width -(len(_ccs[0]) + 3 +\
                                         len(_ccs[2]) + _bright)) +\
                 _ccs[0] + [' ','*',' '] + _ccs[2] + \
                 make_chars(' ',_bright)
        _line2 = make_chars(' ',_width -(len(_ccs[4]) + 3 +\
                                         len(_ccs[2]) + _bright)) +\
                 make_chars('---',len(_ccs[4]) + 3 + len(_ccs[2])) + \
                 make_chars(' ',_bright)
    
        _line3 = make_chars(' ',_width -(len(_ccs[4]) + 3 +\
                                         len(_ccs[2]) + _bright)) +\
                 make_chars('_', len(_ccs[4])) + \
                 make_chars(' ', 3 + len(_ccs[2]) + _bright)
        return [_line1, _line2, _line3]
    
    def _calc_lines(self, _ccs, _width, _bright):
        """format the calc for display as is befor input starts
        from _ccs = [['3','2'],'*',['4'],'=',['1','2','8']]
        make ([(2, 8, '8', '32*4=___', '32*4=__8',
                [' ',' ',' ',' ',' ','_','_','8',' ',' ',' ',' ',' ',' ']),
               (2, 7, '2', '32*4=__8', '32*4=_28',
                [' ',' ',' ',' ',' ','_','2','8',' ',' ',' ',' ',' ',' ']),
               (2, 6, '1', '32*4=_28', '32*4=128',
                [' ',' ',' ',' ',' ','1','2','8',' ',' ',' ',' ',' ',' ']),
              ])
        """
        _inlines = []
        _inpos1 = _width -(3 + len(_ccs[2]) + _bright) #see _init_lines
        _prod = _ccs[4]
        _protoc = flatten(_ccs[0:-1]) + make_chars('_', len(_prod))
        for _ino in range(len(_ccs[4])):
            _in =  _prod[len(_prod)-1 - _ino]
            _protoc2 = copy.deepcopy(_protoc)
            _protoc2[len(_protoc) - _ino -1] = _in
            _prod_ = _protoc2[-len(_prod):] #last elements
            _inline = \
               (2, _inpos1 - _ino -1, _in, 
                strs2str(_protoc), strs2str(_protoc2),
                make_chars(' ', _width -(len(_ccs[4]) + 3 +\
                                         len(_ccs[2]) + _bright)) +\
                    _prod_ +\
                    make_chars(' ',  3 + len(_ccs[2]) + _bright))
            _inlines.append(_inline)
            _protoc = copy.deepcopy(_protoc2)
        _inlines.reverse()
        return _inlines
    
    def format(self, calc):
        """format the calc for display, prepare overlays for input
        from ['3','2','*','4','=','1','2','8']
        make ([[' ',' ',' ',' ',' ',' ','3','2',' ','*',' ','4',' ',' '],
               [' ',' ',' ',' ',' ','-','-','-','-','-','-','-',' ',' '],
               [' ',' ',' ',' ',' ','1','1','8',' ',' ',' ',' ',' ',' ']],
              [TDOD])
        """
        _width = 14     #_width = 14 is Display.width, 
        _bright = 2     #FIXXXME: _bright depends on_width when centering
        _ccalc = collect_digits(calc)
        return (self._init_lines(_ccalc, _width, _bright), 
                self._calc_lines(_ccalc, _width, _bright))
            
    ### buttons ################################################

    def define_buttons(self):
        _max_length = 6 #FIXXXME class variable of ExMult
        _max_width = 9  #FIXXXME class variable of Display
        self.len1_butts = []
        for i in range(_max_length): #len of left factor
            self.toggle = gtk.ToggleButton(str(_max_length-i))
            self.toggle_label = self.toggle.get_child()
            self.toggle_label.modify_font(pango.FontDescription("sans 12"))
            self.toggle.connect("toggled", self.set_len1_callback, i)
            self._dis.settings_table.attach(self.toggle, 0+i, 1+i, 3, 4)
            self.toggle.show()
            self.len1_butts.append(self.toggle)
        self.set_label('*',  _max_length, _max_length+1, 3, 4)
        self.len2_butts = []
        for i in range(2): #max len of right factor
            self.toggle = gtk.ToggleButton(str(i+1))
            self.toggle_label = self.toggle.get_child()
            self.toggle.modify_font(pango.FontDescription("sans 12"))
            self.toggle.connect("toggled", self.set_len2_callback, i)
            self._dis.settings_table.attach(self.toggle, 
                                     _max_length+1+i, _max_length+2+i, 3, 4)
            self.toggle.show()
            self.len2_butts.append(self.toggle)
        for i in range(_max_width):
            self.set_label('-----', i,i+1, 4,5)
        self.set_label('6', 0,1, 5,6)
        self.set_label('5', 1,2, 5,6)
        self.set_label('4', 2,3, 5,6)
        self.set_label('3', 3,4, 5,6)
        self.set_label('2', 4,5, 5,6)
        self.set_label('1', 5,6, 5,6)
        #next line
        self.set_label('1', 0,1, 6,7)
        self.set_label('3', 1,2, 6,7)
        self.set_label('0', 2,3, 6,7)
        self.set_label('8', 3,4, 6,7)
        self.set_label('6', 4,5, 6,7)
        self.set_label('4', 5,6, 6,7)
        self.set_label('2', 6,7, 6,7)
        for i in range(7):
            self.set_label('-----', i,i+1, 7,8)
        self.set_label('7', 0,1, 8,9)
        self.set_label('8', 1,2, 8,9)
        self.set_label('5', 2,3, 8,9)
        self.set_label('1', 3,4, 8,9)
        self.set_label('8', 4,5, 8,9)
        self.set_label('5', 5,6, 8,9)
        self.set_label('2', 6,7, 8,9)
 
    def set_label(self, text, c1,c2, l1,l2):
        self.label = gtk.Label(text)
        self.label.modify_font(pango.FontDescription("sans 12"))
        self._dis.settings_table.attach(self.label, c1,c2, l1,l2)
        self.label.show()

        

    ### set buttons #############################################

    def set_buttons(self, sett): #FIXME remove sett
        #print('---exmult set_buttons')
        _max_length = 6 #FIXXXME ExMult._max_length !
        for i in range(_max_length):
            if  i < _max_length -  self._sett['fact1']:
                self.len1_butts[i].set_active(False)
            else:
                self.len1_butts[i].set_active(True)

        for i in range(2): #max len of right factor
            self.len2_butts[i].set_active(False)
            self.len2_butts[0].set_active(True)

        
    ### callbacks ###############################################

    def set_len1_callback(self, widget, clickno):
        _max_length = 6 #FIXXXME class variable of ExMult
        #print('exmult.set_len1_callback, clickno=',clickno)
        if widget.get_active(): #gtk made just active
            #print('exmult.set_len1_callback,.get_active()=True')
            if(_max_length - clickno > self._sett['fact1']):
                #print('exmult.set_len1_callback, le-cl > fact1')
                self._sett['fact1'] = _max_length - clickno
            elif(_max_length - clickno < 2):
                #print('exmult.set_len1_callback, le-cl < 2')
                pass # not less then "1" button
        else: #gtk made just inactive (before was active)
            #print('exmult.set_len1_callback,.get_active()=False')
            if(_max_length - clickno == self._sett['fact1']):
                #print('exmult.set_len1_callback, le-cl == fact1')
                if(_max_length - clickno < 2):
                    #print('exmult.set_len1_callback, le-cl < 2')
                    widget.set_active(True)
                else:
                    #print('exmult.set_len1_callback, le-cl >= 2')
                    self._sett['fact1'] = _max_length - clickno -1
            else:
                #print('exmult.set_len1_callback, le-cl != fact1')
                widget.set_active(True)
        self.set_buttons(self._sett)

    def set_len2_callback(self, widget, i):
        #max len of right factor can NOT YET be changed
        #due to limited _generate_calcs, format
        self.len2_butts[0].set_active(True)
        self.len2_butts[1].set_active(False)
