import gtk

from sugar.activity import activity
from sugar.graphics.toolbutton import ToolButton

from session import Session


class Toolbar:
    
    def __init__(self, parent):
        self._parent = parent
        
    def show(self):
        
        mytoolbox = gtk.Toolbar()
        
        learner_button = ToolButton() 
        learner_button.set_tooltip("Learner")
        learner_button.connect('clicked', self.toggle_mode, "Learner")

        author_button = ToolButton() 
        author_button.set_tooltip("Author")
        author_button.connect('clicked', self.toggle_mode, "Author")
        
        mytoolbox.insert(author_button, -1)
        author_button.show()
        
        mytoolbox.insert(learner_button, -1)
        learner_button.show()
        mytoolbox.show()

        toolbox = activity.ActivityToolbox(self._parent)
        toolbox.add_toolbar("Switch Learner -- Author",mytoolbox)
        self._parent.set_toolbox(toolbox)
        toolbox.show()

    def toggle_mode(self, args, mode):
        # self._parent._session.close()
        session = Session("xo-user-name", self._parent)
        session.setMode(mode)
        session.run()
        
